-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPals_CoreUtils(b, b1, b2, b3, b4, b5)
-- DESC : This makes everything happen
-- **************************************************************************
function TitanPanelPals_CoreUtils(b, b1, b2, b3, b4, b5, b6, b7, b8)
     if ( TitanPals["Debug"] ) then
          if ( b ) then TitanPals["dLine"] = "[|cffff9900"..b.."|r]" end
          if ( b1 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b1.."|r]" end
          if ( b2 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b2.."|r]" end
          if ( b3 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b3.."|r]" end
          if ( b4 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b4.."|r]" end
          if ( b5 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b5.."|r]" end
          if ( b6 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b6.."|r]" end
          if ( b7 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b7.."|r]" end
          if ( b8 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b8.."|r]" end
          TitanPals["dLine"] = "Recieved "..TitanPals["dLine"];
	  TitanPanelPals_DebugUtils("bug", "dLine", TitanPals["dLine"]);
     end
     if ( b == "UpDate" ) then
          -- [b     ][b1     ][b2   ][b3    ]
          -- [Action][Faction][Realm][Player]
          local NumPals = GetNumFriends();
	  local Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno, noteAL;
	  for fIndex=1, NumPals do
	       --[Name][Level][Class][Area][Connected][Status][Note]
	       Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno = GetFriendInfo(fIndex);
	       local opl, opc, opno;
	       if ( TitanPals["Lists"][palsDB][Palsn] ) then
	            opl, opc, opno = string.match(TitanPals["Lists"][palsDB][Palsn], '(.*):(.*):(.*)');
                    if ( not Palsco ) then 
		         Palsl = opl;
                         Palsc = opc;
			 if ( Palsno == "na" ) then Palsno = opno; end
                    end
	       end
	       if ( not Palsno ) then Palsno = ":na"; 
	       else Palsno = ":"..Palsno; end
	       noteAL = Palsl..":"..Palsc..Palsno;
               TitanPals["Lists"][palsDB][Palsn] = noteAL;
	  end
     elseif ( b == "ToolTip" ) then
          --[b     ][b1   ][b2  ][b3  ][b4   ][b5   ][b6  ][b7    ][b8  ]
          --[Action][Right][Left][Name][Level][Class][Area][Status][Note]
          if ( b4 == 0 ) then b4 = "-"; end
	  if ( b7 == "AFK" ) then b1 = string.gsub(b1, "!s", "<AFK>");
	  elseif ( b7 == "DND" ) then b1 = string.gsub(b1, "!s", "<DND>");
	  else b1 = string.gsub(b1, "!s", " "); end
	  b1 = string.gsub(b1, "!l", TitanPanelPals_ColorUtils("GetCText", "orange", b4))
	  b1 = string.gsub(b1, "!p", TitanPanelPals_ColorUtils("GetCText", "orange", b3))
	  b1 = string.gsub(b1, "!c", TitanPanelPals_ColorUtils("GetCClass", "color", b5, b5))
	  if ( not b8 ) then b1 = string.gsub(b1, "!n", "");
	  else b1 = string.gsub(b1, "!n", TitanPanelPals_ColorUtils("GetCText", "gray", b8)); end
	  b1 = string.gsub(b1, "!z", b6)
	  b1 = string.gsub(b1, "!uc", TitanPanelPals_ColorUtils("GetCClass", "color", b5, b3))

	  if ( b7 == "AFK" ) then b2 = string.gsub(b2, "!s", "<AFK>");
	  elseif ( b7 == "DND" ) then b2 = string.gsub(b2, "!s", "<DND>");
	  else  b2 = string.gsub(b2, "!s", " "); end
	  b2 = string.gsub(b2, "!l", TitanPanelPals_ColorUtils("GetCText", "orange", b4))
	  b2 = string.gsub(b2, "!p", TitanPanelPals_ColorUtils("GetCText", "orange", b3))
	  b2 = string.gsub(b2, "!c", TitanPanelPals_ColorUtils("GetCClass", "color", b5, b5))
	  if ( not b8 ) then b2 = string.gsub(b2, "!n", "");
	  else b2 = string.gsub(b2, "!n", TitanPanelPals_ColorUtils("GetCText", "gray", b8)); end
	  b2 = string.gsub(b2, "!z", b6)
	  b2 = string.gsub(b2, "!uc", TitanPanelPals_ColorUtils("GetCClass", "color", b5, b3))
	  return b1, b2;
     elseif ( b == "Toggle" ) then
          --[b      ][b1 ]
	  --[Action][Var]
          if ( TitanPals[b1] ) then 
	       TitanPals[b1] = false;
	       if ( b1 == "DebugLogEvent" ) then wipe(TitanPals["Temp"]); end
	       if ( b1 == "Debug") then TitanPals["dLine"] = ""; end
          elseif ( not TitanPals[b1] ) then TitanPals[b1] = true; end
     elseif ( b == "mem" ) then
          --[b     ]
	  --[Action]
          UpdateAddOnMemoryUsage();
          TitanPals["dLine"] = TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb");
          TitanPanelPals_DebugUtils("info", "mem", "Titan Panel [|cffeda55fPals|r] is using "..TitanPals["dLine"].." of memory");
     elseif ( b == "playList" ) then
          --[b     ]
	  --[Action]
          local pTable = TitanPals["Temp"];
          for n, v in pairs( pTable ) do
	       TitanPanelPals_DebugUtils("info", "playList", "Name = "..n.." Value = "..v);
          end
     elseif ( b == "playFriends" ) then
          --[b     ]
	  --[Action]
          local pTable = TitanPals["Lists"][palsDB];
	  for n, v in pairs(pTable) do
               local nn = TitanPanelPals_ColorUtils("GetCText", "green", n);
               local vv = TitanPanelPals_ColorUtils("GetCText", "gray", "["..v.."]");
               TitanPanelPals_DebugUtils("info", "playFriends", nn..vv);
          end
     elseif ( b == "playAlts" ) then
          --[b     ]
	  --[Action]
	  local pTable = TitanPals["Alts"][palsDB];
	  for n, v in pairs(pTable) do
	       local nn = TitanPanelPals_ColorUtils("GetCText", "green", n);
	       local vv = TitanPanelPals_ColorUtils("GetCText", "gray", "["..v.."]");
               TitanPanelPals_DebugUtils("info", "playAlts", nn..vv);
	  end
     elseif ( b == "fixDB" ) then
          --[b     ][b1      ][b2            ]
	  --[Action][Database][Name to Remove]
	  TitanPals["Temp"] = {};
	  for n, v in pairs( TitanPals[b1][palsDB] ) do
	       if ( n ~= b2 ) then
	            TitanPals["Temp"][n] = v;
		    TitanPals[b1][palsDB] = {};
		    TitanPals[b1][palsDB] = TitanPals["Temp"];
               end
	  end
     end
end

-- **************************************************************************
-- NAME : TitanPAnelPals_DebugUtils()
-- DESC : For debug messaging and print messages to chat frame
-- **************************************************************************
function TitanPanelPals_DebugUtils(d, d1, d2)
     --[d     ][d1      ][d2   ]
     --[Action][Function][error]
     if ( d == "bug" and TitanPals["Debug"] ) then
          local iDebug = TitanPanelPals_ColorUtils("GetCText", "red", LB["TITAN_PALS_CORE_DTAG"]);
          if ( d1 ~= "dLine" ) then DEFAULT_CHAT_FRAME:AddMessage(iDebug.."["..TitanPanelPals_ColorUtils("GetCText", "orange", d1).."] "..d2); end
	  if ( TitanPals["DebugLogEvent"] ) then tinsert(TitanPals["Temp"], d2); end
     elseif ( d == "info" ) then
          local iInfo = TitanPanelPals_ColorUtils("GetCText", "orange", LB["TITAN_PALS_CORE_ITAG"]);
	  DEFAULT_CHAT_FRAME:AddMessage(iInfo..d2);
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_ColorUtils()
-- DESC : for coloring the tooltip and messages
-- **************************************************************************
function TitanPanelPals_ColorUtils(c, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10)
     if ( c == "GetCText") then
          --[c     ][c1   ][c2  ]
          --[Action][Color][Text]
          if ( c1 == "gray" ) then return LB["TITAN_PALS_COLORS_GRAY"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "red") then return LB["TITAN_PALS_COLORS_RED"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "green" ) then return LB["TITAN_PALS_COLORS_GREEN"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "orange") then return LB["TITAN_PALS_COLORS_ORANGE"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "normal" ) then return LB["TITAN_PALS_COLORS_NORMAL"]..c2..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "hlight" ) then return LB["TITAN_PALS_COLORS_HLIGHT"]..c2..LB["TITAN_PALS_COLORS_CTAG"]; end
     elseif ( c == "GetCClass" ) then
          --[c     ][c1   ][c2   ][c3    ]
          --[Action][Style][Class][Player]
          local colorCode;
          if ( c2 == LB["TITAN_PALS_CLASSES_WARLOCK_M"] ) then colorCode = "|cff9482c9";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_WARLOCK_F"] ) then colorCode = "|cff9482c9";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_DEATHKNIGHT_M"] ) then colorCode = "|cffc41f3b";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_DEATHKNIGHT_F"] ) then colorCode = "|cffc41f3b";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_HUNTER_M"] ) then colorCode = "|cffabd473";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_HUNTER_F"] ) then colorCode = "|cffabd473";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_PRIEST_M"] ) then colorCode = "|cffffffff";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_PRIEST_F"] ) then colorCode = "|cffffffff";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_PALADIN_M"] ) then colorCode = "|cfff58cba";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_PALADIN_F"] ) then colorCode = "|cfff58cba";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_MAGE_M"] ) then colorCode = "|cff69ccf0";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_MAGE_F"] ) then colorCode = "|cff69ccf0";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_ROGUE_M"] ) then colorCode = "|cfffff569";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_ROGUE_F"] ) then colorCode = "|cfffff569";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_DRUID_M"] ) then colorCode = "|cffff7d0a";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_DRUID_F"] ) then colorCode = "|cffff7d0a";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_SHAMAN_M"] ) then colorCode = "|cff2459ff";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_SHAMAN_F"] ) then colorCode = "|cff2459ff";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_WARRIOR_M"] ) then colorCode = "|cffc79c6e";
          elseif ( c2 == LB["TITAN_PALS_CLASSES_WARRIOR_F"] ) then colorCode = "|cffc79c6e";
          else colorCode = "|cffFFFFFF";
          end
          if ( c1 == "color" ) then return colorCode..c3..LB["TITAN_PALS_COLORS_CTAG"];
          elseif ( c1 == "normal" ) then return c3; end
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_FixArray()
-- DESC : Fixes Data Array layout from old version to new
-- **************************************************************************
function TitanPanelPals_FixArray()
     local oArray = TitanPals["Lists"][palsDB];
     TitanPals["Temp"] = {};
     for n, v in pairs(oArray) do
          l, c = string.match(v, '(.*):(.*)');
          TitanPals["Temp"][n] = l..":"..c..":na";
     end
     TitanPals["Lists"][palsDB] = TitanPals["Temp"];
     TitanPals["Temp"] = {};
     if ( not TitanPals["DBVer"][palsDB] ) then TitanPals["DBVer"][palsDB] = "v2"; end
     TitanPanelPals_DebugUtils("info", "Upgrade", "Data Array for "..palsDB.." has been upgraded to current.")
end

-- **************************************************************************
-- NAME : TitanPanelPals_CleanArray()
-- DESC : Cleans Data Array fo old vars
-- **************************************************************************
function TitanPanelPals_CleanArray()
     local tTemp = {};
     tTemp["Debug"] = false;
     tTemp["DebugEvent"] = false;
     tTemp["DebugLogEvent"] = false;
     tTemp["ShowOffline"] = TitanPals["ShowOffline"];
     tTemp["ShowIgnored"] = TitanPals["ShowIgnored"];
     tTemp["ShowMem"] = TitanPals["ShowMem"];
     tTemp["NoAlts"] = TitanPals["NoAlts"];
     tTemp["UpDateDB"] = TitanPals["UpDateDB"];
     tTemp["DisplayB"] = TitanPals["DisplayB"];
     tTemp["dLine"] = "";
     tTemp["Lists"] = TitanPals["Lists"];
     tTemp["Temp"] = {};
     tTemp["Alts"] = TitanPals["Alts"];
     tTemp["DBVer"] = TitanPals["DBVer"];
     tTemp["Init"] = TitanPals["Init"];
     if ( TitanPals["Right"] ) then tTemp["Right"] = TitanPals["Right"];
     else tTemp["Right"] = "!s (!l) !p"; end
     if ( TitanPals["Left"] ) then tTemp["Left"] = TitanPals["Left"];
     else tTemp["Left"] = "!n !z"; end
     if ( TitanPals["TFormat"] ) then tTemp["TFormat"] = TitanPals["TFormat"];
     else tTemp["TFormat"] = "!s (!l !c) !p | !n !z"; end
     tTemp["Selected"] = 1;
     tTemp["Realm"] = TitanPals["Realm"];
     tTemp["Faction"] = TitanPals["Faction"];
     tTemp["Player"] = TitanPals["Player"];
     tTemp["palsDB"] = TitanPals["palsDB"];
     tTemp["Class"] = TitanPals["Class"];
     tTemp["Level"] = TitanPals["Level"];
     tTemp["AddVer"] = LB["TITAN_PALS_CORE_ADDVER"];
     TitanPals = {};
     TitanPals = tTemp;
     tTemp = nil;
end